#!/usr/bin/perl

#-----------------------------------------------------------------------#
# CW Guestbook [Perl]							#
#-----------------------------------------------------------------------#
#     Version:	2.7							#
#      Author:	Skob <skob@cwg.ru>					#
#        Cost:	Free!!!							#
#    Language:	Perl; Russian						#
# Last Update:	29.03.2002						#
#     Archive:	http://www.cwg.ru/download.php?id=gbook			#
#-----------------------------------------------------------------------#
#    HomePage:	www.CWG.ru						#
#     Support:	support.cwg.ru, support@cwg.ru				#
#-----------------------------------------------------------------------#

require "vars.pl";
if (!$version || $version !~ /^(\d+)\.(\d+)$/ || $1*100+$2 < 207) {
	print "Content-Type: text/plain\n\n";
	print "Version Error.\nPlease visit http://support.cwg.ru/faq.php?id=1 for more info!";
	exit;
}

my %FORM;
{
	my $buff;
	if ($ENV{REQUEST_METHOD} eq "POST") {read STDIN, $buff, $ENV{CONTENT_LENGTH}}
	else {$buff=$ENV{QUERY_STRING}}
	
	my @pairs = split(/&/, $buff);
	my $pair;
	foreach $pair (@pairs) {
		my ($name, $value) = split(/=/, $pair);
		$name =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$FORM{$name} = $value;
	}
}

my $ident = $FORM{login};
my $action = $FORM{action};
$errorx="";

my (%STR,$CODEPAGE,$LANG);
{
	my $inisection;
	my $inistr;
	open STR, "$language.lang";
	while ($inistr = <STR>) {
		# Sections
		if ($inistr =~ /^\[([a-zA-Z0-9_]*)\]$/) {$inisection = $1;}
		# Comments
		elsif (substr($inistr,0,1) eq ";") {}
		# Vars
		elsif ($inisection eq 'admin' && $inistr =~ /^([a-zA-Z0-9_]*?)=(.*)$/) {$STR{$1} = $2;}
		elsif ($inisection eq $language && $inistr =~ /^name=(.*)$/) {$LANG = $1;}
		elsif ($inisection eq $language && $inistr =~ /^codepage=(.*)$/) {$CODEPAGE = $1;}
	}
	close STR;
}

my %States = (
	'checkpass'	=> \&checkpass,
	'add'		=> \&add,
	'edit'		=> \&edit,
	'delete'	=> \&delet,
	'change'	=> \&change,
	'design'	=> \&design,
	'changedesign'	=> \&changedesign,
	'changeinfo'	=> \&changeinfo,
	'submitinfo'	=> \&submitinfo,
	'autoexchange'	=> \&autoexchange,
	'aen'		=> \&aen,
	'aed'		=> \&aed,
	'ban ip'	=> \&banip,
	'banlist'	=> \&banlist,
	'bledit'	=> \&bledit
);

if ($States{$action}) {$States{$action}->()}
else {&login}

sub login {
	&html_header(1);
	print qq~
<center><font class=bg3>$errorx</font></center>
<form method=post action=admin.pl>
  <table align=center width=300 border=0 cellspacing=0 cellpadding=0>
  <tr>
    <td align=right><div class=bg3>: &nbsp;</div></td>
    <td><div class=bg3><input class=ed type=text name=login></div></td>
  </tr>
  <tr>
    <td align=right><div class=bg3>: &nbsp;</div></td>
    <td><div class=bg3><input class=ed type=password name=pass></div></td>
  </tr>
  <tr>
    <td align=center colspan=2><div class=bg3><input class=bt type=submit value=></div></td>
  </tr>
  </table>
  <input type=hidden name=action value=checkpass>
</form>
~;

	&html_bottom;
}

sub checkpass {
  if (($adminpass ne $FORM{pass}) || ($adminlogin eq "")) {$errorx=" ";&login;}
  else {
	$pass="";
	while (length($pass) < 30) {
		$k = int rand 24;
		$pass .= chr($k+65);
	}
	$t = time;
	open PWD, ">session.pwd";
	print PWD "$t:$pass";
	close PWD;
	&edit;
  }
}

sub edit {
  if (isok()) {$errorx=" ";&login;}
  else {
	&html_header;
	open(GB,"$gdatp");
	@GB = <GB>;
	close(GB);
	
	## 13.03.2002 ## Skob ####################################################
	##########################################################################

	my $pline = "";
	
	$page = $FORM{page} || 0;
	
	$k = int (($page) / 50);
	
	if ($k > 0) {$pline = "<a class=bg4 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=edit&page=".($k*50-10)."\">&lt;&lt;&lt;</a> "}
	$pline .= '| ';
	for ($i=0;$i<5;$i++) {
		$from = $i*10 + $k*50 + 1;
		$to = $i*10 + $k*50 + 10;
		if ($to > @GB) {$to = @GB}
		if ($from <= $to) {
			if ($page >= $from-1 && $page <= $to-1) {
				$pline .= "<b>$from - $to</b> | ";
			}
			else {
				$pline .= "<a class=bg4 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=edit&page=".($from-1)."\">$from - $to</a> | ";
			}
		}
	}
	if ($to < @GB) {$pline .= " <a class=bg4 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=edit&page=".(($k+1)*50)."\">&gt;&gt;&gt;</a>"}
	$pline .= " &nbsp; &nbsp; <b>[ : ".@GB." ]</b>";
	
	##########################################################################
	
	print "<center class=bg4>$pline</center>";
	
	for($i=$page;$i<$page+10;$i++){
		$indx = @GB - $i;
		if ($indx > 0) {
			@GB[$i] =~ s/\r|\n//g;
			($name,$mail,$hpage,$tim,$city,$text,$ip,$answer) = split(/::/,@GB[$i]);
			$name =~ s/\&\#58\;/:/g;
			$hpage =~ s/\&\#58\;/:/g;
			$city =~ s/\&\#58\;/:/g;
			$mail =~ s/\&\#58\;/:/g;
			$text =~ s/\&\#58\;/:/g;
			$answer =~ s/\&\#58\;/:/g;
			$name =~ s/\"/\&quot\;/g;
			$hpage =~ s/\"/\&quot\;/g;
			$city =~ s/\"/\&quot\;/g;
			$mail =~ s/\"/\&quot\;/g;
			$text =~ s/\"/\&quot\;/g;
			$answer =~ s/\"/\&quot\;/g;
			$text =~ s/<br>/\n/g;
			$answer =~ s/<br>/\n/g;
			$answer =~ s/^0$//;
			$mail =~ s/^0$//;
			$city =~ s/^0$//;
			$hpage =~ s/^0$//;
			print "<form action=admin.pl method=post>\n";
			print "<table cellspacing=0 cellpadding=1 border=0 align=center>\n";
			print "<input name=id type=hidden value=$indx>\n";
			print "<input type=hidden name=page value=$FORM{page}>";
			print "<input name=pass type=hidden value=\"$FORM{pass}\">";
			print "<input name=login type=hidden value=\"$FORM{login}\">\n";
			print "<tr><td align=right class=bg3>:</td>       <td align=center><input style=\"width: 500px;\" name=name type=text value=\"$name\"></td></tr>\n";
			print "<tr><td align=right class=bg3>url:</td>       <td align=center><input style=\"width: 500px;\" name=hpage type=text value=\"$hpage\"></td></tr>\n";
			print "<tr><td align=right class=bg3>E-mail:</td>    <td align=center><input style=\"width: 500px;\" name=mail type=text value=\"$mail\"></td></tr>\n";
			print "<tr><td align=right class=bg3>:</td>     <td align=center><input style=\"width: 500px;\" name=city type=text value=\"$city\"></td></tr>\n";
			print "<tr><td align=right class=bg3>:</td>     <td align=center><input style=\"width: 500px;\" name=tim type=text value=\"$tim\"></td></tr>\n";
			print "<tr><td align=right class=bg3>IP:</td>        <td align=center><input style=\"width: 500px;\" name=ip type=text value=\"$ip\"></td></tr>\n";
			print "<tr><td align=right class=bg3>:</td> <td align=center><textarea style=\"width: 500px;\" name=text rows=5 cols=80>$text</textarea></td></tr>\n";
			print "<tr><td align=right class=bg3>:</td>     <td align=center><textarea style=\"width: 500px;\" name=answer rows=5 cols=80>$answer</textarea></td></tr>\n";
			print "<tr class=bg3><td colspan=2 align=center><input type=submit name=action value=change> <input type=submit style=\"color:#cc0000;\" name=action value=delete> &nbsp; &nbsp; <input type=submit style=\"color:#cc0000;\" name=action value=\"ban ip\"></td></tr>\n";
			print "</table>\n";
			print "</form>\n";
		}
	}
	print "<center class=bg4> $pline </center>";
	print "</body></html>";
	&html_bottom;
	}
}

sub delet {
  if (isok()) {$errorx=" ";&login;}
  else {
	open(GB,"$gdatp");
	@GB = <GB>;
	close(GB);
	$i = @GB;
	open(GB,">$gdatp");
	foreach $gb (@GB) {
		if($i != $FORM{id}){
			print GB "$gb";
		}
		$i--;
	}
	close(GB);
	&edit;
  }
}

sub change {
  if (isok()) {$errorx=" ";&login;}
  else {
	open(GB,"$gdatp");
	@GB = <GB>;
	close(GB);
	$i=0;
	open(GB,">$gdatp");
	$FORM{mail} =~ s/\:/\&\#58\;/g;
	$FORM{name} =~ s/\:/\&\#58\;/g;
	$FORM{hpage} =~ s/\:/\&\#58\;/g;
	$FORM{city} =~ s/\:/\&\#58\;/g;
	$FORM{text} =~ s/\:/\&\#58\;/g;
	$FORM{answer} =~ s/\:/\&\#58\;/g;
	$FORM{ip} =~ s/\:/\&\#58\;/g;
	$FORM{tim} =~ s/\"/\&quot/g;
	$FORM{mail} =~ s/\"/\&quot/g;
	$FORM{name} =~ s/\"/\&quot/g;
	$FORM{hpage} =~ s/\"/\&quot/g;
	$FORM{city} =~ s/\"/\&quot/g;
	$FORM{text} =~ s/\"/\&quot/g;
	$FORM{answer} =~ s/\"/\&quot/g;
	$FORM{ip} =~ s/\"/\&quot/g;
	
	$FORM{text} =~ s/\r/\n/g;$FORM{text} =~ s/\n+/<br>/g;
	$FORM{answer} =~ s/\r/\n/g;$FORM{answer} =~ s/\n+/<br>/g;
	
	if ($FORM{mail} eq "") {$FORM{mail} = "0";}
	if ($FORM{city} eq "") {$FORM{city} = "0";}
	if ($FORM{text} eq "") {$FORM{text} = "0";}
	if ($FORM{answer} eq "") {$FORM{answer} = "0";}
	$i = @GB;
	foreach $gb (@GB) {
		$gb =~ s/\r/\n/g;$gb =~ s/\n+//g;
		if($i != $FORM{id}){
			print GB "$gb\n";
		}
		else{
			$STRING = join("::",$FORM{name},$FORM{mail},$FORM{hpage},$FORM{tim},$FORM{city},$FORM{text},$FORM{ip},$FORM{answer});
			print GB "$STRING\n";
		}
		$i--;
	}
	close(GB);
	&edit;
  }
}

sub design {
  if (isok()) {$errorx=" ";&login;}
  else {
	&html_header;
	print "<form action=admin.pl method=post>";
	print "<table align=center>\n";
	
	print "<tr><td class=bg3 align=center><b class=bg3> html-</b> <a class=bg3 href=#help>help</help></td></tr>\n<tr><td align=center>\n<textarea style=\"font-family: Courier, Courier New; width: 600px;\" cols=100 rows=20 name=htmlp>";
	open(GB,"$htmlp");
	  while ($ttt=<GB>) {$ttt =~ s/\&/\&amp\;/g;$ttt =~ s/\</\&lt\;/g;$ttt =~ s/\>/\&gt\;/g; print "$ttt";}
	close(GB);	
	print "</textarea></td></tr>\n";
	
	print "<tr><td class=bg3 align=center><b class=bg3> </b> <a class=bg3 href=#help>help</help></td></tr>\n<tr><td align=center>\n<textarea style=\"font-family: Courier, Courier New; width: 600px;\" cols=100 rows=20 name=messp>";
	open(GB,"$messp");
	  while ($ttt=<GB>) {$ttt =~ s/\&/\&amp\;/g;$ttt =~ s/\</\&lt\;/g;$ttt =~ s/\>/\&gt\;/g; print "$ttt";}
	close(GB);	
	print "</textarea></td></tr>\n";
	
	print "<tr><td class=bg3 align=center><b class=bg3>   </b> <a class=bg3 href=#help>help</help></td></tr>\n<tr><td align=center>\n<textarea style=\"font-family: Courier, Courier New; width: 600px;\" cols=100 rows=20 name=sendp>";
	open(GB,"$sendp");
	  while ($ttt=<GB>) {$ttt =~ s/\&/\&amp\;/g;$ttt =~ s/\</\&lt\;/g;$ttt =~ s/\>/\&gt\;/g; print "$ttt";}
	close(GB);	
	print "</textarea></td></tr>\n";
	
	print "<tr><td class=bg3 align=center><b class=bg3>  </b> <a class=bg3 href=#help>help</help></td></tr>\n<tr><td align=center>";
	open(GB,"$datep");
	print "<textarea style=\"font-family: Courier, Courier New; width: 600px;\" cols=100 rows=10 name=datep>";
	  while ($ttt=<GB>) {$ttt =~ s/\&/\&amp\;/g;$ttt =~ s/\</\&lt\;/g;$ttt =~ s/\>/\&gt\;/g; print "$ttt";}
	close(GB);
	print "</textarea></td></tr>\n";
	
	print "<tr><td class=bg3 align=center><input type=submit value=></td></tr>\n<tr><td>\n";
	print "<input type=hidden value=changedesign name=action>\n";
	print "<input type=hidden name=pass value=$FORM{pass}>\n";
	print "<input type=hidden name=login value=$FORM{login}>\n</form>\n";

	print "<tr><td class=bg3 align=center><b class=bg3><a name=help>:</a></b></td></tr>\n<tr><td class=bg4>\n";
	open(GB,"help.htpl");
	  while ($ttt=<GB>) {$ttt =~ s/\n/<br>/g; print "$ttt";}
	close(GB);	
	print "</td></tr>\n";
				
	print "</table>";
	&html_bottom;
  }	
}

sub changedesign {
  if (isok()) {$errorx=" ";&login;}
  else {
	open(GB,">$htmlp");
	$FORM{htmlp} =~ s/\&\#58\;/:/g;
	$FORM{htmlp} =~ s/\&\quot\;/\"/g;
	print GB $FORM{htmlp};
	close(GB);
	open(GB,">$messp");
	$FORM{messp} =~ s/\&\#58\;/:/g;
	$FORM{messp} =~ s/\&\quot\;/\"/g;
	print GB $FORM{messp};
	close(GB);
	open(GB,">$sendp");
	$FORM{sendp} =~ s/\&\#58\;/:/g;
	$FORM{sendp} =~ s/\&\quot\;/\"/g;
	print GB $FORM{sendp};
	close(GB);
	open(GB,">$datep");
	$FORM{datep} =~ s/\&\#58\;/:/g;
	$FORM{datep} =~ s/\&\quot\;/\"/g;
	print GB $FORM{datep};
	close(GB);
	&design;
  }
}

sub changeinfo {
  if (isok()) {$errorx=" ";&login;}
  else {
	&html_header;
	print "<form action=admin.pl method=post> ";
	print "<input type=hidden name=pass value=$FORM{pass}>\n";
	print "<input type=hidden name=login value=$FORM{login}>\n";
	print "<input type=hidden name=action value=submitinfo>\n";
	print "<table align=center cellspacing=0 cellpadding=2>\n";
	print "<tr class=bg3><td colspan=2 align=center><b>:</b></td></tr>";
	print "<tr class=bg3><td align=right>  :</td><td align=center><input class=ed type=text size=50 name=mess value=\"$mess\"></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=text name=pages value=\"$pages\"></td></tr>\n";
	
	print "<tr class=bg3><td align=right>  :</td><td align=center><input class=ed size=50 type=text name=max value=\"$max\"></td></tr>\n";
	print "<tr class=bg3><td align=right>  :</td><td align=center><input class=ed size=50 type=text name=maxname value=\"$maxname\"></td></tr>\n";
	print "<tr class=bg3><td align=right>  e-mail:</td><td align=center><input class=ed size=50 type=text name=maxemail value=\"$maxemail\"></td></tr>\n";
	print "<tr class=bg3><td align=right>  url:</td><td align=center><input class=ed size=50 type=text name=maxurl value=\"$maxurl\"></td></tr>\n";
	print "<tr class=bg3><td align=right>  :</td><td align=center><input class=ed size=50 type=text name=maxcity value=\"$maxcity\"></td></tr>\n";
	print "<tr class=bg3><td align=right>  :</td><td align=center><input class=ed size=50 type=text name=maxword value=\"$maxword\"></td></tr>\n";
	
	print "<tr class=bg3><td align=right>  :</td><td align=left class=bg4><input".(($linestyle == 1) ? " checked ": " ")."style=\"border:none; background:none;\" type=radio name=linestyle value=1> | 1 - 10 | 11 - 20 | 21 - 24 | &gt;&gt;&gt;<br><input".(($linestyle == 2) ? " checked ": " ")."style=\"border:none; background:none;\" type=radio name=linestyle value=2> | 1 | 2 | 3 | &gt;&gt;&gt;</td></tr>\n";
	
	print "<tr class=bg3><td align=right>GMT(  ):</td><td align=center><input class=ed size=50 type=text name=gmt value=\"$gmt\"></td></tr>\n";
	print "<tr class=bg3><td align=center colspan=2 class=bg4></td></tr>\n";
	print "<tr class=bg3><td align=right>Cookies( ):</td><td align=center><input class=ed size=50 type=text name=cookname value=\"$cookname\"></td></tr>\n";
	print "<tr class=bg3><td align=right>Cookies( URL):</td><td align=center><input class=ed size=50 type=text name=cookurl value=\"$cookurl\"></td></tr>\n";
	print "<tr class=bg3><td align=right>Cookies( e-mail):</td><td align=center><input class=ed size=50 type=text name=cookmail value=\"$cookmail\"></td></tr>\n";
	print "<tr class=bg3><td align=right>Cookies( ):</td><td align=center><input class=ed size=50 type=text name=cookcity value=\"$cookcity\"></td></tr>\n";
	
	print "<tr class=bg3><td align=center colspan=2 class=bg4></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=text name=gdatp value=\"$gdatp\"></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=text name=exchp value=\"$exchp\"></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=text name=banp value=\"$banp\"></td></tr>\n";
	print "<tr class=bg3><td align=right>  :</td><td align=center><input class=ed size=50 type=text name=datep value=\"$datep\"></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=text name=htmlp value=\"$htmlp\"></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=text name=messp value=\"$messp\"></td></tr>\n";
	print "<tr class=bg3><td align=right>  :</td><td align=center><input class=ed size=50 type=text name=sendp value=\"$sendp\"></td></tr>\n";
	
	print "<tr class=bg3><td align=center colspan=2 class=bg4></td></tr>\n";
	print "<tr class=bg3><td align=right>  SendMail:</td><td align=center><input class=ed size=50 type=text name=sendmailpath value=\"$sendmailpath\"></td></tr>\n";
	print "<tr class=bg3><td align=center colspan=2> <input".(($sendmail eq 'yes') ? " checked" : "")." style=\"border:none; background:none;\" type=checkbox name=sendmail value=\"yes\">      e-mail($adminmail) </td></tr>\n";
	
	print "<tr class=bg3><td align=center colspan=2 class=bg4> (      )</td></tr>\n";
	print "<tr class=bg3><td align=right>:</td><td align=center><input class=ed size=50 type=text name=newlogin value=\"$ident\"></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=password name=oldpass></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=password name=newpass1></td></tr>\n";
	print "<tr class=bg3><td align=right> :</td><td align=center><input class=ed size=50 type=password name=newpass2></td></tr>\n";
	print "<tr class=bg3><td align=right>E-mail:</td><td align=center><input class=ed size=50 type=text name=newmail value=\"$adminmail\"></td></tr>\n";
	
	print "<tr class=bg3><td colspan=2 align=center><input class=bt type=submit value=></td></tr>";
	print "</table></form>";
  }	
}

sub submitinfo {
  if (isok()) {$errorx=" ";&login;}
  else {
	open VARS, ">vars.pl";
	print VARS "#   CW Guestbook $version\n\n";
	if ($FORM{oldpass} eq $adminpass) {
		print VARS "\$adminlogin = '".bs($FORM{newlogin})."';\n";
		print VARS "\$adminmail = '".bs($FORM{newmail})."';\n";
		if ($FORM{newpass1} eq $FORM{newpass2} && $FORM{newpass1}) {
			print VARS "\$adminpass = '".bs($FORM{newpass1})."';\n";
		}
		else {
			print VARS "\$adminpass = '".bs($adminpass)."';\n";
		}
	}
	else {
		print VARS "\$adminlogin = '".bs($adminlogin)."';\n";
		print VARS "\$adminmail = '".bs($adminmail)."';\n";
		print VARS "\$adminpass = '".bs($adminpass)."';\n";
	}
	print VARS "\$banp = '".bs($FORM{banp})."';\n";
	print VARS "\$cookcity = '".bs($FORM{cookcity})."';\n";
	print VARS "\$cookmail = '".bs($FORM{cookmail})."';\n";
	print VARS "\$cookname = '".bs($FORM{cookname})."';\n";
	print VARS "\$cookurl = '".bs($FORM{cookurl})."';\n";
	print VARS "\$datep = '".bs($FORM{datep})."';\n";
	print VARS "\$exchp = '".bs($FORM{exchp})."';\n";
	print VARS "\$gdatp = '".bs($FORM{gdatp})."';\n";
	print VARS "\$gmt = '".bs($FORM{gmt})."';\n";
	print VARS "\$htmlp = '".bs($FORM{htmlp})."';\n";
	print VARS "\$language = 'russian';\n";
	print VARS "\$linestyle = '".bs($FORM{linestyle})."';\n";
	print VARS "\$max = '".bs($FORM{max})."';\n";
	print VARS "\$maxcity = '".bs($FORM{maxcity})."';\n";
	print VARS "\$maxemail = '".bs($FORM{maxemail})."';\n";
	print VARS "\$maxname = '".bs($FORM{maxname})."';\n";
	print VARS "\$maxurl = '".bs($FORM{maxurl})."';\n";
	print VARS "\$maxword = '".bs($FORM{maxword})."';\n";
	print VARS "\$mess = '".bs($FORM{mess})."';\n";
	print VARS "\$messp = '".bs($FORM{messp})."';\n";
	print VARS "\$pages = '".bs($FORM{pages})."';\n";
	print VARS "\$sendmail = '".(($FORM{pages} eq 'yes') ? "yes" : "no")."';\n";
	print VARS "\$sendmailpath = '".bs($FORM{sendmailpath})."';\n";
	print VARS "\$sendp = '".bs($FORM{sendp})."';\n";
	print VARS "\$version = '$version';\n";
	close VARS;
	&changeinfo;
  }
}

sub bs {
	my $bk = shift;
	$bk =~ s/\\/\\\\/g;
	$bk =~ s/\'/\\\'/g;
	return $bk;
}

sub html_header {
	my $ss = shift;
print "Content-type: text/html\n\n";
print <<LLL;
<html>
<head>
<title>   CWG.ru</title>
<style>
.bg0 {color: #E0D3D3; font-size: 10px; font-family: Verdana, Tahoma}
.bg1 {color: #E0D3D3; font-size: 9px; font-family: Verdana, Tahoma}
.bg2 {color: #8D6565; font-size: 9px; font-family: Verdana, Tahoma}
.bg3 {color: #8D6565; font-size: 12px; font-family: Verdana, Tahoma}
.bg4 {color: #8D6565; font-size: 10px; font-family: Verdana, Tahoma}
a.bg4:link {color: #6b4343; text-decoration: none;}
a.bg4:visited {color: #7C5454; text-decoration: none;}
a.bg4:active {color: #7C5454; text-decoration: none;}
a.bg4:hover {color: #000000; text-decoration: underline;}
a.bg3:link {color: #5a3232; text-decoration: none;}
a.bg3:visited {color: #5a3232; text-decoration: none;}
a.bg3:active {color: #5a3232; text-decoration: none;}
a.bg3:hover {color: #000000; text-decoration: underline;}
a.bg2:link {color: #8D6565; text-decoration: none;}
a.bg2:visited {color: #8D6565; text-decoration: none;}
a.bg2:active {color: #8D6565; text-decoration: none;}
a.bg2:hover {color: #8D6565; text-decoration: underline;}
INPUT, TEXTAREA {background: url(http://www.cwg.ru/bg1.gif) #E0D3D3 ;border: 1 solid #CCABAB; color: #5a3232;}
</style>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
<meta http-equiv="pragma" content="no-cache">
</head>

<body bgcolor="#E0D3D3" topmargin=0 background="http://www.cwg.ru/bg0.gif" leftmargin=0 style="background: url(http://www.cwg.ru/bg0.gif) repeat-y #E0D3D3; " text="#AD8282" marginwidth=0 marginheight=0>
<table border=0 cellspacing=0 cellpadding=0 width=434 background=http://www.cwg.ru/logo.gif height=50>
  <tr>
    <td class=bg0 align=center valign=top>   CWG.ru</td>
  </tr>
</table>

<table width=760 border=0 cellspacing=2 cellpadding=0>
<tr>
<td valign=top>
  <table width=756 border=0 cellspacing=1 cellpadding=1 bgcolor=#8D6565>
    <tr bgcolor="#CCABAB"> 
      <td height=10 class=bg2 align=center><b><a href=http://cwg.ru class=bg2>www.CWG.ru</a></b></td>
    </tr>
    <tr> 
      <td background=http://www.cwg.ru/bg2.gif height=365 valign=top class=bg3 bgcolor=#E0D3D3>

LLL
	mbanner() if (!$ss);
	if (!$ss) {print "<script src=http://www.cwg.ru/cgi-bin/myversion.pl?script=gbook&version=$version></script>\n";}
}

sub html_bottom {
print <<LLL;
      </td>
    </tr>
  </table>
<tr><td>
  <table width=756 border=0 cellspacing=1 cellpadding=1 bgcolor=#8D6565>
    <tr> 
      <td bgcolor=#E0D3D3 background=http://www.cwg.ru/bg2.gif valign=top class=bg4>&nbsp;<img src=http://www.cwg.ru/ar2.gif border=0> Design: <a class=bg4 href=mailto:ectb\@cwg.ru>ECTb</a></td>
    </tr>
  </table>
</td></tr>
</table>
</body>
</html>
LLL
}

sub autoexchange {
  if (isok()) {$errorx=" ";&login;}
  else {
	&html_header;
	print "<table align=center>\n<form action=admin.pl method=post>\n";
	print "<tr class=bg3><td align=center class=bg3 colspan=2><b>:</b></td></tr>\n";
	print "<tr><td class=bg3 align=right></td><td><input class=ed type=text name=wh1></td></tr>\n";
	print "<tr><td class=bg3 align=right> </td><td><input class=ed type=text name=wh2></td></tr>\n";
	print "<tr class=bg3><td align=center colspan=2><input type=submit class=bt value=></td></tr>\n";
	print "<input type=hidden name=login value=$FORM{login}>\n";
	print "<input type=hidden name=pass value=$FORM{pass}>\n";
	print "<input type=hidden name=action value=aen>\n";
	print "</form></table><br><br>\n";

	print "<table align=center>\n";
	print "<tr><td class=bg3></td><td class=bg3></td><td class=bg3></td></tr>";
	open (AE,"$exchp");
	$ii=0;
	while (<AE>){
		($wh1,$wh2) = split (/\|\|/,$_);
		$ii++;
		$wh2 =~ s/\&/\&amp\;/g;$wh2 =~ s/\"/\&quot\;/g;$wh2 =~ s/</\&lt\;/g;$wh2 =~ s/>/\&gt\;/g;$wh1 =~ s/\\\\/\\/g;$wh1 =~ s/\\\:/:/g;$wh1 =~ s/\\\)/)/g;$wh1 =~ s/\\\(/(/g;$wh1 =~ s/\\\;/\;/g;$wh1 =~ s/\\\"/\"/g;$wh1 =~ s/\\\]/\]/g;$wh1 =~ s/\\\[/\[/g;$wh1 =~ s/\\\}/\}/g;$wh1 =~ s/\\\{/\{/g;$wh1 =~ s/\\\./\./g;$wh1 =~ s/\\\*/\*/g;$wh1 =~ s/\\\@/\@/g;$wh1 =~ s/\\\$/\$/g;$wh1 =~ s/\\\&/\&/g;$wh1 =~ s/\\\!/\!/g;$wh1 =~ s/\\\#/\#/g;$wh1 =~ s/\\\%/\%/g;$wh1 =~ s/\\\^/\^/g;$wh1 =~ s/\\\+/\+/g;$wh1 =~ s/\\\-/\-/g;$wh1 =~ s/\\\//\//g;$wh1 =~ s/\\\?/\?/g;$wh1 =~ s/\\\'/\'/g;$wh1 =~ s/\\\,/\,/g;
		print "<tr><td class=bg3 background=http://www.cwg.ru/bg1.gif>$wh1</td><td class=bg3 background=http://www.cwg.ru/bg1.gif>$wh2</td><td class=bg3 background=http://www.cwg.ru/bg1.gif><a class=bg3 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=aed&num=$ii\"></a></td></tr>";
	}
	close(AE);
	&html_bottom;
  }
}

sub aed {
  if (isok()) {$errorx=" ";&login;}
  else {
	open (AE,"$exchp");
	@AE=<AE>;
	close(AE);
	$ii=0;
	open (AE,">$exchp");
	foreach $ae (@AE){
		$ii++;
		if($ii ne $FORM{num}){print AE "$ae";}
	}
	close(AE);
	&autoexchange;
  }
}

sub aen {
  if (isok()) {$errorx=" ";&login;}
  else {
	open (AE,">>$exchp");
		$wh1=$FORM{wh1};$wh1 =~ s/\\/\\\\/g;$wh1 =~ s/\:/\\\:/g;$wh1 =~ s/\)/\\\)/g;$wh1 =~ s/\(/\\\(/g;$wh1 =~ s/\;/\\\;/g;$wh1 =~ s/\"/\\\"/g;$wh1 =~ s/\]/\\\]/g;$wh1 =~ s/\[/\\\[/g;$wh1 =~ s/\}/\\\}/g;$wh1 =~ s/\{/\\\{/g;$wh1 =~ s/\./\\\./g;$wh1 =~ s/\*/\\\*/g;$wh1 =~ s/\@/\\\@/g;$wh1 =~ s/\$/\\\$/g;$wh1 =~ s/\&/\\\&/g;$wh1 =~ s/\!/\\\!/g;$wh1 =~ s/\#/\\\#/g;$wh1 =~ s/\%/\\\%/g;$wh1 =~ s/\^/\\\^/g;$wh1 =~ s/\+/\\\+/g;$wh1 =~ s/\-/\\\-/g;$wh1 =~ s/\//\\\//g;$wh1 =~ s/\?/\\\?/g;$wh1 =~ s/\'/\\\'/g;$wh1 =~ s/\,/\\\,/g;	
	print AE "$wh1||$FORM{wh2}\n";
	close(AE);
	&autoexchange;
  }
}

sub banip {
  if (isok()) {$errorx=" ";&login;}
  else {
	open (BAN,">>$banp");
	if ($FORM{whyban} eq ""){print BAN "$FORM{ip}|banned\n";}
	else {print BAN "$FORM{ip}|$FORM{whyban}\n";}
	close(BAN);
	if ($FORM{goto} eq ""){&edit;}
	else {&banlist;}
  }
}

sub banlist {
  if (isok()) {$errorx=" ";&login;}
  else {
	&html_header;
	print "<table align=center>\n<form action=admin.pl method=post>\n";
	print "<tr class=bg3><td colspan=2 align=center><b>:</b></td></tr>\n";
	print "<tr class=bg3><td align=right>IP</td><td><input type=text class=ed name=ip></td></tr>\n";
	print "<tr class=bg3><td align=right></td><td><input class=ed type=text name=whyban></td></tr>\n";
	print "<tr class=bg3><td colspan=2 align=center><input type=submit class=bt value=></td></tr>\n";
	print "<input type=hidden name=login value=$FORM{login}>\n";
	print "<input type=hidden name=pass value=$FORM{pass}>\n";
	print "<input type=hidden name=action value=\"ban ip\">\n";
	print "<input type=hidden name=goto value=\"banlist\">\n";
	print "</form></table><br><br>\n";

	print "<table align=center><tr class=bg3><td>IP</td><td></td><td> </td></tr>\n";
	open (BAN,"$banp");
	@BANS=<BAN>;
	close(BAN);
	$ll=0;
	#open (BAN,">$banp");
	foreach $ban (@BANS){
		chomp($ban);
		($ban1,$ban2) = split (/\|/,$ban);
		print "<form action=admin.pl method=post>\n";
		print "<tr>\n<td><input type=text class=ed size=15 name=bip value=\"$ban1\"></td>\n";
		print "<td><input class=ed type=text size=45 name=bdes value=\"$ban2\"></td>\n";
		print "<td><input class=bt type=submit name=do value=change> <input type=submit style=\"background-color:pink;\" name=do value=delete></td>\n</tr>\n";
		print "<input type=hidden name=login value=$FORM{login}>\n";
		print "<input type=hidden name=pass value=$FORM{pass}>\n";
		print "<input type=hidden name=action value=bledit>\n";
		print "<input type=hidden name=num value=$ll>\n";
		print "</form>";
		$ll++;
	}
	print "</table>";
	#close(BAN);
  }
}

sub bledit {
  if (isok()) {$errorx=" ";&login;}
  else {
	open (BAN,"$banp");
	@BANS=<BAN>;
	close(BAN);
	open (BAN,">$banp");
	$ll=0;
	foreach $ban (@BANS){
	     if ($ll ne $FORM{num}){
		 print BAN "$ban";
	     }
	     else {
		 if ($FORM{do} eq "change"){print BAN "$FORM{bip}\|$FORM{bdes}\n"}
	     }
	     $ll++;
	}
	close(BAN);
	&banlist;
  }
}

sub isok {
	open PWD, "session.pwd";
	$pwd = <PWD>;
	close PWD;
	my ($t,$p) = split (/\:/,$pwd);
	if ($t > (time - 600) and $FORM{login} eq $adminlogin and ($adminpass eq $FORM{pass} or $p eq $FORM{pass})) {
	 open PWD, ">session.pwd";
	 $t = time;
	 print PWD "$t:$p";
	 close PWD;
	 $FORM{pass} = $p;
	 return 0;
	}
	else {return 1;}
}

sub mbanner {
	
	print "<div class=bg3>\n";
	if ($action ne 'edit') {
		print "<a class=bg3 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=edit\">,  .</a><br>\n";
	}
	if ($action ne 'design') {
		print "<a class=bg3 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=design\"> .</a><br>\n";
	}
	if ($action ne 'autoexchange') {
		print "<a class=bg3 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=autoexchange\">   .</a><br>\n";
	}
	if ($action ne 'changeinfo') {
		print "<a class=bg3 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=changeinfo\"> .</a><br>\n";
	}
	if ($action ne 'banlist') {
		print "<a class=bg3 href=\"admin.pl?login=$FORM{login}&pass=$FORM{pass}&action=banlist\"> -.</a><br>\n";
	}
	print "<a class=bg3 href=\"http://support.cwg.ru\" target=_blank>  CWG.ru</a><br>\n";
	print "<br><a class=bg3 target=_blank href=guest.pl> </a><br></div>";
}